﻿using System;
using System.Collections.Generic;
using System.Diagnostics.SymbolStore;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace ThePreuferСode
{
    internal class Program
    {
        static void Main(string[] args)
        {
            int?[,] matrix = Program.reading();

            DecisionPruferCode decisionPruferCode = new DecisionPruferCode();
            decisionPruferCode.Decision(matrix);
        }

        private static int?[,] reading()
        {
            int n = File.ReadAllLines("InitialGraphTree.txt").Length;
            int?[,] graph = new int?[n, 2];
            using (StreamReader reader = new StreamReader("InitialGraphTree.txt"))
            {
                for (int i = 0; i < n; i++)
                {
                    string text = reader.ReadLine();
                    string[] mas = text.Split(new char[] { ',' });
                    for (int j = 0; j < mas.Length; j++)
                    {
                        graph[i, j] = int.Parse(mas[j]);
                    }

                }

            }
            return graph;
        }
    }

    public class DecisionPruferCode
    {
        public void Decision(int?[,] matrix)
        {
            List<int> Result = new List<int>();
            List<int> node = new List<int>();

            for (int i = 0; i < matrix.GetLength(0); i++)
            {
                for(int j = 0;j < matrix.GetLength(1); j++)
                {
                    if (!node.Contains((int)matrix[i, j]))
                    {
                        node.Add((int)matrix[i, j]);
                    }
                }

            }
            node.Sort();
            bool flag = true;

            while (flag)
            {
                int countMin;
                int rowMin = -2;
                int colMin = -2;
                for (int n = 0; n < node.Count; n++)
                {
                    countMin = 0;
                    for (int i = 0; i < matrix.GetLength(0); i++)
                    {
                        for (int j = 0; j < matrix.GetLength(1); j++)
                        {
                            if (node[n] == matrix[i, j])
                            {
                                countMin++;
                                rowMin = i;
                                colMin = j;
                            }

                        }
                        
                    }
                    if(countMin == 1)
                    {
                        break;
                    }
                }
                if (colMin == 0)
                {
                    Result.Add((int)matrix[rowMin, 1]);
                    node.Remove((int)matrix[rowMin,colMin]);
                    matrix[rowMin, 1] = null;
                    matrix[rowMin, 0] = null;
                }
                else if(colMin == 1)
                {
                    Result.Add((int)matrix[rowMin, 0]);
                    node.Remove((int)matrix[rowMin,colMin]);
                    matrix[rowMin, 1] = null;
                    matrix[rowMin, 0] = null;
                }

                int count = 0;
                for (int i = 0; i < matrix.GetLength(0); i++)
                {
                    for (int j = 0; j < matrix.GetLength(1); j++)
                    {
                        if (matrix[i, j] != null)
                        {
                            count++;
                        }
                    }
                }
                if (count == 2)
                {
                    flag = false;
                }
            }
            writing(Result);
        }
        private void writing(List<int> result)
        {
            FileStream file1 = new FileStream("ResultCodePrufer.txt", FileMode.OpenOrCreate);
            StreamWriter writer = new StreamWriter(file1);
            writer.WriteLine("Итоговый код Прюфера: ");
            for (int i = 0; i < result.Count; i++)
            {
                writer.Write(result[i] + " ");
            }
            writer.Close();
        }
    }
}
